<?php

/******************************************************************************/
/******************************************************************************/

class ThemeMenuWalker extends Walker_Nav_Menu 
{
	/**************************************************************************/

	function start_lvl(&$output,$depth=0,$args=array()) 
	{
		$output.='<ul>';
	}

	/**************************************************************************/
	
	function end_lvl(&$output,$depth=0,$args=array()) 
	{
		$output.='</ul>';
	}

	/**************************************************************************/
	
	function start_el(&$output,$object,$depth=0,$args=array(),$current_object_id=0) 
	{		
		$span=null;
		
		if($depth==0) $span='<span></span>';
		
		$output.=
		'
			<li class="'.join(' ',(array)$object->classes).'">
				<a href="'.esc_attr($object->url).'">'.esc_html($object->title).$span.'</a>
		';
	}

	/**************************************************************************/
	
	function end_el(&$output,$object,$depth=0,$args=array())
	{
		$output.='</li>';
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/